{
  "openapi": "3.0.3",
  "info": {
    "title": "Server API v3 (deprecated)",
    "description": "> 🚧 Deprecation Notice\n>\n> This version of Server API is marked as deprecated starting on **Jan 7th 2026** according to our [API Deprecation Policy](https://docs.fingerprint.com/reference/api-deprecation-policy). If you still use this version, please follow our [migration guide](https://docs.fingerprint.com/reference/migrating-from-server-api-v3-to-v4) to migrate from this deprecated version to the new one.\n\nFingerprint Server API allows you to search, update, and delete identification events in a server environment. It can be used for data exports, decision-making, and data analysis scenarios.\nServer API is intended for server-side usage, it's not intended to be used from the client side, whether it's a browser or a mobile device.\n",
    "version": "3",
    "contact": {
      "name": "Fingerprint Support",
      "email": "support@fingerprint.com"
    },
    "license": {
      "name": "MIT",
      "url": "https://github.com/fingerprintjs/openapi/blob/main/LICENSE"
    }
  },
  "tags": [
    {
      "name": "Fingerprint",
      "description": "Using the Server API you can retrieve information about individual analysis events or event history of individual visitors.",
      "externalDocs": {
        "description": "API documentation",
        "url": "https://docs.fingerprint.com/reference/v3/server-api"
      }
    }
  ],
  "servers": [
    {
      "url": "https://api.fpjs.io",
      "description": "Global"
    },
    {
      "url": "https://eu.api.fpjs.io",
      "description": "EU"
    },
    {
      "url": "https://ap.api.fpjs.io",
      "description": "Asia (Mumbai)"
    }
  ],
  "security": [
    {
      "ApiKeyHeader": []
    },
    {
      "ApiKeyQuery": []
    }
  ],
  "paths": {
    "/events/{request_id}": {
      "get": {
        "tags": [
          "Fingerprint"
        ],
        "operationId": "getEvent",
        "summary": "Get event by request ID",
        "description": "> 🚧 Deprecation Notice\n>\n> This version of Server API is marked as deprecated starting on **Jan 7th 2026** according to our [API Deprecation Policy](https://docs.fingerprint.com/reference/api-deprecation-policy). If you still use this version, please follow our [migration guide](https://docs.fingerprint.com/reference/migrating-from-server-api-v3-to-v4#migrating-get-/events) to migrate from this deprecated version to the new one.\n\nGet a detailed analysis of an individual identification event, including Smart Signals. \nPlease note that the response includes mobile signals (e.g. `rootApps`) even if the request originated from a non-mobile platform.\nIt is highly recommended that you **ignore** the mobile signals for such requests. \n\nUse `requestId` as the URL path parameter. This API method is scoped to a request, i.e. all returned information is by `requestId`.\n",
        "parameters": [
          {
            "name": "request_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "The unique [identifier](https://docs.fingerprint.com/reference/v3/js-agent-get-function#requestid) of each identification request."
          }
        ],
        "responses": {
          "200": {
            "description": "OK.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EventsGetResponse"
                },
                "examples": {
                  "200-full": {
                    "summary": "Example response",
                    "value": {
                      "products": {
                        "identification": {
                          "data": {
                            "visitorId": "Ibk1527CUFmcnjLwIs4A9",
                            "requestId": "1708102555327.NLOjmg",
                            "incognito": true,
                            "linkedId": "somelinkedId",
                            "tag": {},
                            "time": "2019-05-21T16:40:13Z",
                            "timestamp": 1582299576512,
                            "url": "https://www.example.com/login?hope{this{works[!",
                            "ip": "61.127.217.15",
                            "ipLocation": {
                              "accuracyRadius": 10,
                              "latitude": 49.982,
                              "longitude": 36.2566,
                              "postalCode": "61202",
                              "timezone": "Europe/Dusseldorf",
                              "city": {
                                "name": "Dusseldorf"
                              },
                              "country": {
                                "code": "DE",
                                "name": "Germany"
                              },
                              "continent": {
                                "code": "EU",
                                "name": "Europe"
                              },
                              "subdivisions": [
                                {
                                  "isoCode": "63",
                                  "name": "North Rhine-Westphalia"
                                }
                              ]
                            },
                            "browserDetails": {
                              "browserName": "Chrome",
                              "browserMajorVersion": "74",
                              "browserFullVersion": "74.0.3729",
                              "os": "Windows",
                              "osVersion": "7",
                              "device": "Other",
                              "userAgent": "Mozilla/5.0 (Windows NT 6.1; Win64; x64) ...."
                            },
                            "confidence": {
                              "score": 0.97
                            },
                            "visitorFound": false,
                            "firstSeenAt": {
                              "global": "2022-03-16T11:26:45.362Z",
                              "subscription": "2022-03-16T11:31:01.101Z"
                            },
                            "lastSeenAt": {
                              "global": null,
                              "subscription": null
                            },
                            "sdk": {
                              "platform": "js",
                              "version": "3.11.10",
                              "integrations": [
                                {
                                  "name": "fingerprint-pro-react",
                                  "version": "3.11.10",
                                  "subintegration": {
                                    "name": "preact",
                                    "version": "10.21.0"
                                  }
                                }
                              ]
                            },
                            "replayed": false
                          }
                        },
                        "botd": {
                          "data": {
                            "bot": {
                              "result": "notDetected"
                            },
                            "url": "https://www.example.com/login?hope{this{works}[!",
                            "ip": "61.127.217.15",
                            "time": "2019-05-21T16:40:13.000Z",
                            "userAgent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/120.0.0.0 YaBrowser/24.1.0.0 Safari/537.36",
                            "requestId": "1708102555327.NLOjmg"
                          }
                        },
                        "rootApps": {
                          "data": {
                            "result": false
                          }
                        },
                        "emulator": {
                          "data": {
                            "result": false
                          }
                        },
                        "ipInfo": {
                          "data": {
                            "v4": {
                              "address": "94.142.239.124",
                              "geolocation": {
                                "accuracyRadius": 20,
                                "latitude": 50.05,
                                "longitude": 14.4,
                                "postalCode": "150 00",
                                "timezone": "Europe/Prague",
                                "city": {
                                  "name": "Prague"
                                },
                                "country": {
                                  "code": "CZ",
                                  "name": "Czechia"
                                },
                                "continent": {
                                  "code": "EU",
                                  "name": "Europe"
                                },
                                "subdivisions": [
                                  {
                                    "isoCode": "10",
                                    "name": "Hlavni mesto Praha"
                                  }
                                ]
                              },
                              "asn": {
                                "asn": "7922",
                                "name": "COMCAST-7922",
                                "network": "73.136.0.0/13",
                                "type": "isp"
                              },
                              "datacenter": {
                                "result": true,
                                "name": "DediPath"
                              }
                            },
                            "v6": {
                              "address": "2001:db8:3333:4444:5555:6666:7777:8888",
                              "geolocation": {
                                "accuracyRadius": 5,
                                "latitude": 49.982,
                                "longitude": 36.2566,
                                "postalCode": "10112",
                                "timezone": "Europe/Berlin",
                                "city": {
                                  "name": "Berlin"
                                },
                                "country": {
                                  "code": "DE",
                                  "name": "Germany"
                                },
                                "continent": {
                                  "code": "EU",
                                  "name": "Europe"
                                },
                                "subdivisions": [
                                  {
                                    "isoCode": "BE",
                                    "name": "Land Berlin"
                                  }
                                ]
                              },
                              "asn": {
                                "asn": "6805",
                                "name": "Telefonica Germany",
                                "network": "2a02:3100::/24",
                                "type": "isp"
                              },
                              "datacenter": {
                                "result": false,
                                "name": ""
                              }
                            }
                          }
                        },
                        "ipBlocklist": {
                          "data": {
                            "result": false,
                            "details": {
                              "emailSpam": false,
                              "attackSource": false
                            }
                          }
                        },
                        "tor": {
                          "data": {
                            "result": false
                          }
                        },
                        "vpn": {
                          "data": {
                            "result": false,
                            "confidence": "high",
                            "mlScore": 0.002,
                            "originTimezone": "Europe/Berlin",
                            "originCountry": "unknown",
                            "methods": {
                              "timezoneMismatch": false,
                              "publicVPN": false,
                              "auxiliaryMobile": false,
                              "osMismatch": false,
                              "relay": false,
                              "mlPrediction": false
                            }
                          }
                        },
                        "proxy": {
                          "data": {
                            "result": true,
                            "confidence": "high",
                            "mlScore": 0.99,
                            "details": {
                              "proxyType": "residential",
                              "lastSeenAt": "2025-08-12T13:00:00Z"
                            }
                          }
                        },
                        "incognito": {
                          "data": {
                            "result": false
                          }
                        },
                        "tampering": {
                          "data": {
                            "result": false,
                            "anomalyScore": 0.1955,
                            "antiDetectBrowser": false
                          }
                        },
                        "clonedApp": {
                          "data": {
                            "result": false
                          }
                        },
                        "factoryReset": {
                          "data": {
                            "time": "1970-01-01T00:00:00Z",
                            "timestamp": 0
                          }
                        },
                        "jailbroken": {
                          "data": {
                            "result": false
                          }
                        },
                        "frida": {
                          "data": {
                            "result": false
                          }
                        },
                        "privacySettings": {
                          "data": {
                            "result": false
                          }
                        },
                        "virtualMachine": {
                          "data": {
                            "result": true,
                            "mlScore": 0.2
                          }
                        },
                        "rawDeviceAttributes": {
                          "data": {
                            "architecture": {
                              "value": 127
                            },
                            "audio": {
                              "value": 35.73832903057337
                            },
                            "canvas": {
                              "value": {
                                "Winding": true,
                                "Geometry": "4dce9d6017c3e0c052a77252f29f2b1c",
                                "Text": "dd2474a56ff78c1de3e7a07070ba3b7d"
                              }
                            },
                            "colorDepth": {
                              "value": 30
                            },
                            "colorGamut": {
                              "value": "p3"
                            },
                            "contrast": {
                              "value": 0
                            },
                            "cookiesEnabled": {
                              "value": true
                            },
                            "cpuClass": {},
                            "fonts": {
                              "value": [
                                "Arial Unicode MS",
                                "Gill Sans",
                                "Helvetica Neue",
                                "Menlo"
                              ]
                            }
                          }
                        },
                        "highActivity": {
                          "data": {
                            "result": false
                          }
                        },
                        "locationSpoofing": {
                          "data": {
                            "result": false
                          }
                        },
                        "velocity": {
                          "data": {
                            "distinctIp": {
                              "intervals": {
                                "5m": 1,
                                "1h": 1,
                                "24h": 1
                              }
                            },
                            "distinctLinkedId": {},
                            "distinctCountry": {
                              "intervals": {
                                "5m": 1,
                                "1h": 2,
                                "24h": 2
                              }
                            },
                            "events": {
                              "intervals": {
                                "5m": 1,
                                "1h": 5,
                                "24h": 5
                              }
                            },
                            "ipEvents": {
                              "intervals": {
                                "5m": 1,
                                "1h": 5,
                                "24h": 5
                              }
                            },
                            "distinctIpByLinkedId": {
                              "intervals": {
                                "5m": 1,
                                "1h": 5,
                                "24h": 5
                              }
                            },
                            "distinctVisitorIdByLinkedId": {
                              "intervals": {
                                "5m": 1,
                                "1h": 5,
                                "24h": 5
                              }
                            }
                          }
                        },
                        "developerTools": {
                          "data": {
                            "result": false
                          }
                        },
                        "mitmAttack": {
                          "data": {
                            "result": false
                          }
                        },
                        "rareDevice": {
                          "data": {
                            "result": false,
                            "percentileBucket": "<p95"
                          }
                        },
                        "proximity": {
                          "data": {
                            "id": "w1aTfd4MCvl",
                            "precisionRadius": 10,
                            "confidence": 0.95
                          }
                        },
                        "labels": {
                          "data": [
                            {
                              "label": "fraud",
                              "prediction": false,
                              "mlScore": 0.01
                            }
                          ]
                        }
                      }
                    }
                  },
                  "200-all-errors": {
                    "summary": "All failed signals",
                    "value": {
                      "products": {
                        "identification": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "botd": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "ipInfo": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "incognito": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "rootApps": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "clonedApp": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "factoryReset": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "jailbroken": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "frida": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "emulator": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "ipBlocklist": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "tor": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "vpn": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "proxy": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "privacySettings": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "virtualMachine": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "tampering": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "rawDeviceAttributes": {
                          "data": {
                            "audio": {
                              "error": {
                                "name": "Error",
                                "message": "internal server error"
                              }
                            },
                            "canvas": {
                              "error": {
                                "name": "Error",
                                "message": "internal server error"
                              }
                            }
                          }
                        },
                        "locationSpoofing": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "highActivity": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "suspectScore": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "velocity": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "developerTools": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "mitmAttack": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "rareDevice": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "proximity": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "labels": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        }
                      }
                    }
                  },
                  "200-identification-error": {
                    "summary": "Identification error",
                    "value": {
                      "products": {
                        "identification": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        },
                        "botd": {
                          "data": {
                            "bot": {
                              "result": "bad",
                              "type": "headlessChrome"
                            },
                            "url": "https://example.com/login",
                            "ip": "94.60.143.223",
                            "time": "2024-02-23T10:20:25.287Z",
                            "userAgent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) HeadlessChrome/121.0.6167.57 Safari/537.36",
                            "requestId": "1708683625245.tuJ4nD"
                          }
                        }
                      }
                    }
                  },
                  "200-botd-error": {
                    "summary": "BotD error",
                    "value": {
                      "products": {
                        "identification": {
                          "data": {
                            "visitorId": "Ibk1527CUFmcnjLwIs4A9",
                            "requestId": "0KSh65EnVoB85JBmloQK",
                            "incognito": true,
                            "linkedId": "somelinkedId",
                            "time": "2019-05-21T16:40:13.000Z",
                            "tag": {},
                            "timestamp": 1582299576512,
                            "url": "https://www.example.com/login",
                            "ip": "61.127.217.15",
                            "ipLocation": {
                              "accuracyRadius": 10,
                              "latitude": 49.982,
                              "longitude": 36.2566,
                              "postalCode": "61202",
                              "timezone": "Europe/Dusseldorf",
                              "city": {
                                "name": "Dusseldorf"
                              },
                              "continent": {
                                "code": "EU",
                                "name": "Europe"
                              },
                              "country": {
                                "code": "DE",
                                "name": "Germany"
                              },
                              "subdivisions": [
                                {
                                  "isoCode": "63",
                                  "name": "North Rhine-Westphalia"
                                }
                              ]
                            },
                            "browserDetails": {
                              "browserName": "Chrome",
                              "browserMajorVersion": "74",
                              "browserFullVersion": "74.0.3729",
                              "os": "Windows",
                              "osVersion": "7",
                              "device": "Other",
                              "userAgent": "Mozilla/5.0 (Windows NT 6.1; Win64; x64) ...."
                            },
                            "confidence": {
                              "score": 0.97
                            },
                            "visitorFound": true,
                            "firstSeenAt": {
                              "global": "2022-03-16T11:26:45.362Z",
                              "subscription": "2022-03-16T11:31:01.101Z"
                            },
                            "lastSeenAt": {
                              "global": "2022-03-16T11:28:34.023Z",
                              "subscription": null
                            },
                            "replayed": false
                          }
                        },
                        "botd": {
                          "error": {
                            "code": "Failed",
                            "message": "internal server error"
                          }
                        }
                      }
                    }
                  },
                  "200-too-many-requests-error": {
                    "summary": "Too many requests error",
                    "value": {
                      "products": {
                        "identification": {
                          "error": {
                            "code": "429 Too Many Requests",
                            "message": "too many requests"
                          }
                        },
                        "botd": {
                          "error": {
                            "code": "TooManyRequests",
                            "message": "too many requests"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Forbidden. Access to this API is denied.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "403-token-required": {
                    "summary": "Error response when the secret API key was not provided.",
                    "value": {
                      "error": {
                        "code": "TokenRequired",
                        "message": "secret key is required"
                      }
                    }
                  },
                  "403-token-not-found": {
                    "summary": "Error response when the provided secret API key does not exist.",
                    "value": {
                      "error": {
                        "code": "TokenNotFound",
                        "message": "secret key is not found"
                      }
                    }
                  },
                  "403-wrong-region": {
                    "summary": "Error response when the API region is different from the region, the calling application is configured with.",
                    "value": {
                      "error": {
                        "code": "WrongRegion",
                        "message": "wrong region"
                      }
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The request ID cannot be found in this application's data.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "404-request-not-found": {
                    "summary": "Error response when the provided request ID does not exist.",
                    "value": {
                      "error": {
                        "code": "RequestNotFound",
                        "message": "request id is not found"
                      }
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "Too Many Requests. The request is throttled.\nTo protect service stability during rare periods of extreme load, we may return HTTP 429 responses with message `too many search requests` even if you are within your assigned rate limits.\n",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "429-too-many-requests": {
                    "summary": "Error response when the limit on the provided secret API key requests per second has been exceeded.",
                    "value": {
                      "error": {
                        "code": "TooManyRequests",
                        "message": "too many requests"
                      }
                    }
                  },
                  "429-too-many-search-requests": {
                    "summary": "Error response when search traffic is throttled to protect service stability during rare periods of extreme load, even if you are within your assigned rate limits.",
                    "value": {
                      "error": {
                        "code": "TooManyRequests",
                        "message": "too many search requests"
                      }
                    }
                  }
                }
              }
            }
          },
          "504": {
            "description": "Gateway Timeout. Search execution exceeded the allowed timeout window.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "504-search-timeout-exceeded": {
                    "summary": "Error response when search execution exceeds the allowed timeout window.",
                    "value": {
                      "error": {
                        "code": "Failed",
                        "message": "gateway timeout"
                      }
                    }
                  }
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Fingerprint"
        ],
        "operationId": "updateEvent",
        "summary": "Update an event with a given request ID",
        "description": "> 🚧 Deprecation Notice\n>\n> This version of Server API is marked as deprecated starting on **Jan 7th 2026** according to our [API Deprecation Policy](https://docs.fingerprint.com/reference/api-deprecation-policy). If you still use this version, please follow our [migration guide](https://docs.fingerprint.com/reference/migrating-from-server-api-v3-to-v4#migrating-update-/events) to migrate from this deprecated version to the new one.\n\nChange information in existing events specified by `requestId` or *flag suspicious events*.\n\nWhen an event is created, it is assigned `linkedId` and `tag` submitted through the JS agent parameters. This information might not be available on the client so the Server API allows for updating the attributes after the fact.\n\n**Warning** It's not possible to update events older than 10 days.\n",
        "parameters": [
          {
            "name": "request_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "The unique event [identifier](https://docs.fingerprint.com/reference/v3/js-agent-get-function#requestid)."
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EventsUpdateRequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK."
          },
          "400": {
            "description": "Bad request. The request payload is not valid.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "example": {
                    "summary": "Error response when the specified request payload is not valid and cannot be parsed.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "request body is not valid"
                      }
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Forbidden. Access to this API is denied.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "403-token-required": {
                    "summary": "Error response when the secret API key was not provided.",
                    "value": {
                      "error": {
                        "code": "TokenRequired",
                        "message": "secret key is required"
                      }
                    }
                  },
                  "403-token-not-found": {
                    "summary": "Error response when the provided secret API key does not exist.",
                    "value": {
                      "error": {
                        "code": "TokenNotFound",
                        "message": "secret key is not found"
                      }
                    }
                  },
                  "403-wrong-region": {
                    "summary": "Error response when the API region is different from the region, the calling application is configured with.",
                    "value": {
                      "error": {
                        "code": "WrongRegion",
                        "message": "wrong region"
                      }
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The request ID cannot be found in this application's data.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "404-request-not-found": {
                    "summary": "Error response when the provided request ID does not exist.",
                    "value": {
                      "error": {
                        "code": "RequestNotFound",
                        "message": "request id is not found"
                      }
                    }
                  }
                }
              }
            }
          },
          "409": {
            "description": "Conflict. The event is not mutable yet.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "example": {
                    "summary": "Error response when the event is not mutable yet.",
                    "value": {
                      "error": {
                        "code": "StateNotReady",
                        "message": "resource is not mutable yet, try again"
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    },
    "/events/search": {
      "get": {
        "tags": [
          "Fingerprint"
        ],
        "operationId": "searchEvents",
        "summary": "Get events via search",
        "description": "> 🚧 Deprecation Notice\n>\n> This version of Server API is marked as deprecated starting on **Jan 7th 2026** according to our [API Deprecation Policy](https://docs.fingerprint.com/reference/api-deprecation-policy). If you still use this version, please follow our [migration guide](https://docs.fingerprint.com/reference/migrating-from-server-api-v3-to-v4#migrating-get-/events/search) to migrate from this deprecated version to the new one.\n\nSearch for identification events, including Smart Signals, using multiple filtering criteria. If you don't provide `start` or `end` parameters, the default search range is the last 7 days.\n\nPlease note that events include mobile signals (e.g. `rootApps`) even if the request originated from a non-mobile platform. We recommend you **ignore** mobile signals for such requests.\n",
        "parameters": [
          {
            "name": "limit",
            "in": "query",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32",
              "minimum": 1,
              "example": 10
            },
            "description": "Limit the number of events returned.\n"
          },
          {
            "name": "pagination_key",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "description": "Use `pagination_key` to get the next page of results.\n\nWhen more results are available (e.g., you requested up to 200 results for your search using `limit`, but there are more than 200 events total matching your request), the `paginationKey` top-level attribute is added to the response. The key corresponds to the `timestamp` of the last returned event. In the following request, use that value in the `pagination_key` parameter to get the next page of results:\n\n1. First request, returning most recent 200 events: `GET api-base-url/events/search?limit=200`\n2. Use `response.paginationKey` to get the next page of results: `GET api-base-url/events/search?limit=200&pagination_key=1740815825085`\n"
          },
          {
            "name": "visitor_id",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "description": "Unique [visitor identifier](https://docs.fingerprint.com/reference/v3/js-agent-get-function#visitorid) issued by Fingerprint Identification and all active Smart Signals.\nFilter for events matching this `visitor_id`.\n"
          },
          {
            "name": "bot",
            "in": "query",
            "schema": {
              "type": "string",
              "enum": [
                "all",
                "good",
                "bad",
                "none"
              ]
            },
            "description": "Filter events by the Bot Detection result, specifically:\n  `all` - events where any kind of bot was detected.\n  `good` - events where a good bot was detected.\n  `bad` - events where a bad bot was detected.\n  `none` - events where no bot was detected.\n> Note: When using this parameter, only events with the `products.botd.data.bot.result` property set to a valid value are returned. Events without a `products.botd` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "ip_address",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "description": "Filter events by IP address range. The range can be as specific as a single IP (/32 for IPv4 or /128 for IPv6)\nAll ip_address filters must use CIDR notation, for example, 10.0.0.0/24, 192.168.0.1/32\n"
          },
          {
            "name": "linked_id",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "description": "Filter events by your custom identifier.\n\nYou can use [linked IDs](https://docs.fingerprint.com/reference/v3/js-agent-get-function#linkedid) to associate identification requests with your own identifier, for example, session ID, purchase ID, or transaction ID. You can then use this `linked_id` parameter to retrieve all events associated with your custom identifier.\n"
          },
          {
            "name": "start",
            "in": "query",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "description": "Filter events with a timestamp greater than the start time, in Unix time (milliseconds).\n"
          },
          {
            "name": "end",
            "in": "query",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "description": "Filter events with a timestamp smaller than the end time, in Unix time (milliseconds).\n"
          },
          {
            "name": "reverse",
            "in": "query",
            "schema": {
              "type": "boolean",
              "default": false
            },
            "description": "When `true`, sort events oldest first (ascending timestamp order). Default is newest first (descending timestamp order).\n"
          },
          {
            "name": "suspect",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events previously tagged as suspicious via the [Update API](https://docs.fingerprint.com/reference/v3/server-api-update-event).\n> Note: When using this parameter, only events with the `suspect` property explicitly set to `true` or `false` are returned. Events with undefined `suspect` property are left out of the response.\n"
          },
          {
            "name": "vpn",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by VPN Detection result.\n> Note: When using this parameter, only events with the `products.vpn.data.result` property set to `true` or `false` are returned. Events without a `products.vpn` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "virtual_machine",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Virtual Machine Detection result.\n> Note: When using this parameter, only events with the `products.virtualMachine.data.result` property set to `true` or `false` are returned. Events without a `products.virtualMachine` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "tampering",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Tampering Detection result.\n> Note: When using this parameter, only events with the `products.tampering.data.result` property set to `true` or `false` are returned. Events without a `products.tampering` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "anti_detect_browser",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Anti-detect Browser Detection result.\n> Note: When using this parameter, only events with the `products.tampering.data.antiDetectBrowser` property set to `true` or `false` are returned. Events without a `products.tampering` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "incognito",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Browser Incognito Detection result.\n> Note: When using this parameter, only events with the `products.incognito.data.result` property set to `true` or `false` are returned. Events without a `products.incognito` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "privacy_settings",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Privacy Settings Detection result.\n> Note: When using this parameter, only events with the `products.privacySettings.data.result` property set to `true` or `false` are returned. Events without a `products.privacySettings` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "jailbroken",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Jailbroken Device Detection result.\n> Note: When using this parameter, only events with the `products.jailbroken.data.result` property set to `true` or `false` are returned. Events without a `products.jailbroken` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "frida",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Frida Detection result.\n> Note: When using this parameter, only events with the `products.frida.data.result` property set to `true` or `false` are returned. Events without a `products.frida` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "factory_reset",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Factory Reset Detection result.\n> Note: When using this parameter, only events with the `products.factoryReset.data.result` property set to `true` or `false` are returned. Events without a `products.factoryReset` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "cloned_app",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Cloned App Detection result.\n> Note: When using this parameter, only events with the `products.clonedApp.data.result` property set to `true` or `false` are returned. Events without a `products.clonedApp` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "emulator",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Android Emulator Detection result.\n> Note: When using this parameter, only events with the `products.emulator.data.result` property set to `true` or `false` are returned. Events without a `products.emulator` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "root_apps",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Rooted Device Detection result.\n> Note: When using this parameter, only events with the `products.rootApps.data.result` property set to `true` or `false` are returned. Events without a `products.rootApps` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "vpn_confidence",
            "in": "query",
            "schema": {
              "type": "string",
              "enum": [
                "high",
                "medium",
                "low"
              ]
            },
            "description": "Filter events by VPN Detection result confidence level.\n`high` - events with high VPN Detection confidence.\n`medium` - events with medium VPN Detection confidence.\n`low` - events with low VPN Detection confidence.\n> Note: When using this parameter, only events with the `products.vpn.data.confidence` property set to a valid value are returned. Events without a `products.vpn` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "min_suspect_score",
            "in": "query",
            "schema": {
              "type": "number",
              "format": "float"
            },
            "description": "Filter events with Suspect Score result above a provided minimum threshold.\n> Note: When using this parameter, only events where the `products.suspectScore.data.result` property set to a value exceeding your threshold are returned. Events without a `products.suspectScore` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "ip_blocklist",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by IP Blocklist Detection result.\n> Note: When using this parameter, only events with the `products.ipBlocklist.data.result` property set to `true` or `false` are returned. Events without a `products.ipBlocklist` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "datacenter",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Datacenter Detection result.\n> Note: When using this parameter, only events with the `products.ipInfo.data.v4.datacenter.result` or `products.ipInfo.data.v6.datacenter.result` property set to `true` or `false` are returned. Events without a `products.ipInfo` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "developer_tools",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Developer Tools detection result.\n> Note: When using this parameter, only events with the `products.developerTools.data.result` property set to `true` or `false` are returned. Events without a `products.developerTools` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "location_spoofing",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Location Spoofing detection result.\n> Note: When using this parameter, only events with the `products.locationSpoofing.data.result` property set to `true` or `false` are returned. Events without a `products.locationSpoofing` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "mitm_attack",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by MITM (Man-in-the-Middle) Attack detection result.\n> Note: When using this parameter, only events with the `products.mitmAttack.data.result` property set to `true` or `false` are returned. Events without a `products.mitmAttack` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "rare_device",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Rare Device detection result.\n> Note: When using this parameter, only events with the `products.rareDevice.data.result` property set to `true` or `false` are returned. Events without a `products.rareDevice` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "rare_device_percentile_bucket",
            "in": "query",
            "schema": {
              "type": "string",
              "enum": [
                "<p95",
                "p95-p99",
                "p99-p99.5",
                "p99.5-p99.9",
                "p99.9+",
                "not_seen"
              ]
            },
            "description": "Filter events by Rare Device percentile bucket. `<p95` - device configuration is in the bottom 95% (most common). `p95-p99` - device is in the 95th to 99th percentile. `p99-p99.5` - device is in the 99th to 99.5th percentile. `p99.5-p99.9` - device is in the 99.5th to 99.9th percentile. `p99.9+` - device is in the top 0.1% (rarest). `not_seen` - device configuration has never been observed before.\n"
          },
          {
            "name": "proxy",
            "in": "query",
            "schema": {
              "type": "boolean"
            },
            "description": "Filter events by Proxy detection result.\n> Note: When using this parameter, only events with the `products.proxy.data.result` property set to `true` or `false` are returned. Events without a `products.proxy` Smart Signal result are left out of the response.\n"
          },
          {
            "name": "sdk_version",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "description": "Filter events by a specific SDK version associated with the identification event. Example: `3.11.14`\n"
          },
          {
            "name": "sdk_platform",
            "in": "query",
            "schema": {
              "type": "string",
              "enum": [
                "js",
                "android",
                "ios"
              ]
            },
            "description": "Filter events by the SDK Platform associated with the identification event.\n`js` - JavaScript agent (Web).\n`ios` - Apple iOS based devices.\n`android` - Android based devices.\n"
          },
          {
            "name": "environment",
            "in": "query",
            "description": "Filter for events by providing one or more environment IDs.\n",
            "required": false,
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "style": "form",
            "explode": true
          },
          {
            "name": "proximity_id",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "description": "Filter events by the most precise Proximity ID provided by default.\n> Note: When using this parameter, only events with the `products.proximity.id` property matching the provided ID are returned. Events without a `products.proximity` result are left out of the response.\n"
          },
          {
            "name": "proximity_precision_radius",
            "in": "query",
            "schema": {
              "type": "integer",
              "format": "int32",
              "enum": [
                10,
                25,
                65,
                175,
                450,
                1200,
                3300,
                8500,
                22500
              ]
            },
            "description": "Filter events by Proximity Radius.\n> Note: When using this parameter, only events with the `products.proximity.precisionRadius` property set to a valid value are returned. Events without a `products.proximity` result are left out of the response.\n"
          }
        ],
        "responses": {
          "200": {
            "description": "Events matching the filter(s).",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SearchEventsResponse"
                },
                "examples": {
                  "200-full": {
                    "summary": "Example search results",
                    "value": {
                      "events": [
                        {
                          "products": {
                            "identification": {
                              "data": {
                                "visitorId": "Ibk1527CUFmcnjLwIs4A9",
                                "requestId": "1708102555327.NLOjmg",
                                "incognito": true,
                                "linkedId": "somelinkedId",
                                "tag": {},
                                "time": "2019-05-21T16:40:13Z",
                                "timestamp": 1582299576512,
                                "url": "https://www.example.com/login?hope{this{works[!",
                                "ip": "61.127.217.15",
                                "ipLocation": {
                                  "accuracyRadius": 10,
                                  "latitude": 49.982,
                                  "longitude": 36.2566,
                                  "postalCode": "61202",
                                  "timezone": "Europe/Dusseldorf",
                                  "city": {
                                    "name": "Dusseldorf"
                                  },
                                  "country": {
                                    "code": "DE",
                                    "name": "Germany"
                                  },
                                  "continent": {
                                    "code": "EU",
                                    "name": "Europe"
                                  },
                                  "subdivisions": [
                                    {
                                      "isoCode": "63",
                                      "name": "North Rhine-Westphalia"
                                    }
                                  ]
                                },
                                "browserDetails": {
                                  "browserName": "Chrome",
                                  "browserMajorVersion": "74",
                                  "browserFullVersion": "74.0.3729",
                                  "os": "Windows",
                                  "osVersion": "7",
                                  "device": "Other",
                                  "userAgent": "Mozilla/5.0 (Windows NT 6.1; Win64; x64) ...."
                                },
                                "confidence": {
                                  "score": 0.97
                                },
                                "visitorFound": false,
                                "firstSeenAt": {
                                  "global": "2022-03-16T11:26:45.362Z",
                                  "subscription": "2022-03-16T11:31:01.101Z"
                                },
                                "lastSeenAt": {
                                  "global": null,
                                  "subscription": null
                                },
                                "replayed": false
                              }
                            },
                            "botd": {
                              "data": {
                                "bot": {
                                  "result": "notDetected"
                                },
                                "url": "https://www.example.com/login?hope{this{works}[!",
                                "ip": "61.127.217.15",
                                "time": "2019-05-21T16:40:13.000Z",
                                "userAgent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/120.0.0.0 YaBrowser/24.1.0.0 Safari/537.36",
                                "requestId": "1708102555327.NLOjmg"
                              }
                            },
                            "rootApps": {
                              "data": {
                                "result": false
                              }
                            },
                            "emulator": {
                              "data": {
                                "result": false
                              }
                            },
                            "ipInfo": {
                              "data": {
                                "v4": {
                                  "address": "94.142.239.124",
                                  "geolocation": {
                                    "accuracyRadius": 20,
                                    "latitude": 50.05,
                                    "longitude": 14.4,
                                    "postalCode": "150 00",
                                    "timezone": "Europe/Prague",
                                    "city": {
                                      "name": "Prague"
                                    },
                                    "country": {
                                      "code": "CZ",
                                      "name": "Czechia"
                                    },
                                    "continent": {
                                      "code": "EU",
                                      "name": "Europe"
                                    },
                                    "subdivisions": [
                                      {
                                        "isoCode": "10",
                                        "name": "Hlavni mesto Praha"
                                      }
                                    ]
                                  },
                                  "asn": {
                                    "asn": "7922",
                                    "name": "COMCAST-7922",
                                    "network": "73.136.0.0/13",
                                    "type": "isp"
                                  },
                                  "datacenter": {
                                    "result": true,
                                    "name": "DediPath"
                                  }
                                },
                                "v6": {
                                  "address": "2001:db8:3333:4444:5555:6666:7777:8888",
                                  "geolocation": {
                                    "accuracyRadius": 5,
                                    "latitude": 49.982,
                                    "longitude": 36.2566,
                                    "postalCode": "10112",
                                    "timezone": "Europe/Berlin",
                                    "city": {
                                      "name": "Berlin"
                                    },
                                    "country": {
                                      "code": "DE",
                                      "name": "Germany"
                                    },
                                    "continent": {
                                      "code": "EU",
                                      "name": "Europe"
                                    },
                                    "subdivisions": [
                                      {
                                        "isoCode": "BE",
                                        "name": "Land Berlin"
                                      }
                                    ]
                                  },
                                  "asn": {
                                    "asn": "6805",
                                    "name": "Telefonica Germany",
                                    "network": "2a02:3100::/24",
                                    "type": "isp"
                                  },
                                  "datacenter": {
                                    "result": false,
                                    "name": ""
                                  }
                                }
                              }
                            },
                            "ipBlocklist": {
                              "data": {
                                "result": false,
                                "details": {
                                  "emailSpam": false,
                                  "attackSource": false
                                }
                              }
                            },
                            "tor": {
                              "data": {
                                "result": false
                              }
                            },
                            "vpn": {
                              "data": {
                                "result": false,
                                "confidence": "high",
                                "mlScore": 0.002,
                                "originTimezone": "Europe/Berlin",
                                "originCountry": "unknown",
                                "methods": {
                                  "timezoneMismatch": false,
                                  "publicVPN": false,
                                  "auxiliaryMobile": false,
                                  "osMismatch": false,
                                  "relay": false,
                                  "mlPrediction": false
                                }
                              }
                            },
                            "proxy": {
                              "data": {
                                "result": false,
                                "confidence": "high",
                                "mlScore": 0.7,
                                "details": {
                                  "proxyType": "residential",
                                  "lastSeenAt": "2025-08-12T13:00:00Z"
                                }
                              }
                            },
                            "incognito": {
                              "data": {
                                "result": false
                              }
                            },
                            "tampering": {
                              "data": {
                                "result": false,
                                "anomalyScore": 0.1955,
                                "antiDetectBrowser": false
                              }
                            },
                            "clonedApp": {
                              "data": {
                                "result": false
                              }
                            },
                            "factoryReset": {
                              "data": {
                                "time": "1970-01-01T00:00:00Z",
                                "timestamp": 0
                              }
                            },
                            "jailbroken": {
                              "data": {
                                "result": false
                              }
                            },
                            "frida": {
                              "data": {
                                "result": false
                              }
                            },
                            "privacySettings": {
                              "data": {
                                "result": false
                              }
                            },
                            "virtualMachine": {
                              "data": {
                                "result": true,
                                "mlScore": 0.2
                              }
                            },
                            "rawDeviceAttributes": {
                              "data": {
                                "architecture": {
                                  "value": 127
                                },
                                "audio": {
                                  "value": 35.73832903057337
                                },
                                "canvas": {
                                  "value": {
                                    "Winding": true,
                                    "Geometry": "4dce9d6017c3e0c052a77252f29f2b1c",
                                    "Text": "dd2474a56ff78c1de3e7a07070ba3b7d"
                                  }
                                },
                                "colorDepth": {
                                  "value": 30
                                },
                                "colorGamut": {
                                  "value": "p3"
                                },
                                "contrast": {
                                  "value": 0
                                },
                                "cookiesEnabled": {
                                  "value": true
                                },
                                "cpuClass": {},
                                "fonts": {
                                  "value": [
                                    "Arial Unicode MS",
                                    "Gill Sans",
                                    "Helvetica Neue",
                                    "Menlo"
                                  ]
                                }
                              }
                            },
                            "highActivity": {
                              "data": {
                                "result": false
                              }
                            },
                            "locationSpoofing": {
                              "data": {
                                "result": false
                              }
                            },
                            "velocity": {
                              "data": {
                                "distinctIp": {
                                  "intervals": {
                                    "5m": 1,
                                    "1h": 1,
                                    "24h": 1
                                  }
                                },
                                "distinctLinkedId": {},
                                "distinctCountry": {
                                  "intervals": {
                                    "5m": 1,
                                    "1h": 2,
                                    "24h": 2
                                  }
                                },
                                "events": {
                                  "intervals": {
                                    "5m": 1,
                                    "1h": 5,
                                    "24h": 5
                                  }
                                },
                                "ipEvents": {
                                  "intervals": {
                                    "5m": 1,
                                    "1h": 5,
                                    "24h": 5
                                  }
                                },
                                "distinctIpByLinkedId": {
                                  "intervals": {
                                    "5m": 1,
                                    "1h": 5,
                                    "24h": 5
                                  }
                                },
                                "distinctVisitorIdByLinkedId": {
                                  "intervals": {
                                    "5m": 1,
                                    "1h": 5,
                                    "24h": 5
                                  }
                                }
                              }
                            },
                            "developerTools": {
                              "data": {
                                "result": false
                              }
                            },
                            "mitmAttack": {
                              "data": {
                                "result": false
                              }
                            },
                            "rareDevice": {
                              "data": {
                                "result": false,
                                "percentileBucket": "<p95"
                              }
                            },
                            "proximity": {
                              "data": {
                                "id": "w1aTfd4MCvl",
                                "precisionRadius": 10,
                                "confidence": 0.95
                              }
                            }
                          }
                        }
                      ],
                      "paginationKey": "1655373953086"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Bad request. One or more supplied search parameters are invalid, or a required parameter is missing.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "400-limit-invalid": {
                    "summary": "Error response when no limit is supplied, or is invalid.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "invalid limit"
                      }
                    }
                  },
                  "400-ip-address-invalid": {
                    "summary": "Error response when an invalid IP address is supplied, or is not using CIDR notation.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "invalid ip address"
                      }
                    }
                  },
                  "400-bot-type-invalid": {
                    "summary": "Error response when an invalid bot type is specified, must be one of `good`, `bad`, `all`, or `none`.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "invalid bot type"
                      }
                    }
                  },
                  "400-reverse-invalid": {
                    "summary": "Error response when the reverse parameter is invalid.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "invalid reverse param"
                      }
                    }
                  },
                  "400-start-time-invalid": {
                    "summary": "Error response when an invalid start time is supplied.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "invalid start time"
                      }
                    }
                  },
                  "400-end-time-invalid": {
                    "summary": "Error response when an invalid end time is supplied.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "invalid end time"
                      }
                    }
                  },
                  "400-visitor-id-invalid": {
                    "summary": "Error response when an invalid visitor ID is supplied.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "invalid visitor id"
                      }
                    }
                  },
                  "400-linked-id-invalid": {
                    "summary": "Error response when an invalid (too large) linked ID is supplied.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "linked_id can't be greater than 256 characters long"
                      }
                    }
                  },
                  "400-pagination-key-invalid": {
                    "summary": "Error response when an invalid pagination key is supplied.",
                    "value": {
                      "error": {
                        "code": "RequestCannotBeParsed",
                        "message": "invalid pagination key"
                      }
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Forbidden. Access to this API is denied.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "403-token-required": {
                    "summary": "Error response when the secret API key was not provided.",
                    "value": {
                      "error": {
                        "code": "TokenRequired",
                        "message": "secret key is required"
                      }
                    }
                  },
                  "403-token-not-found": {
                    "summary": "Error response when the provided secret API key does not exist.",
                    "value": {
                      "error": {
                        "code": "TokenNotFound",
                        "message": "secret key is not found"
                      }
                    }
                  },
                  "403-wrong-region": {
                    "summary": "Error response when the API region does not match the region of your Fingerprint workspace.",
                    "value": {
                      "error": {
                        "code": "WrongRegion",
                        "message": "wrong region"
                      }
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The requested visitor does not exist in this application's data.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "404-visitor-not-found": {
                    "summary": "Error response when the provided visitor ID does not exist.",
                    "value": {
                      "error": {
                        "code": "VisitorNotFound",
                        "message": "visitor not found"
                      }
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "Too Many Requests. The request is throttled.\nTo protect service stability during rare periods of extreme load, we may return HTTP 429 responses with message `too many search requests` even if you are within your assigned rate limits.\n",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "429-too-many-requests": {
                    "summary": "Error response when the limit on the provided secret API key requests per second has been exceeded.",
                    "value": {
                      "error": {
                        "code": "TooManyRequests",
                        "message": "too many requests"
                      }
                    }
                  },
                  "429-too-many-search-requests": {
                    "summary": "Error response when search traffic is throttled to protect service stability during rare periods of extreme load, even if you are within your assigned rate limits.",
                    "value": {
                      "error": {
                        "code": "TooManyRequests",
                        "message": "too many search requests"
                      }
                    }
                  }
                }
              }
            }
          },
          "504": {
            "description": "Gateway Timeout. Search execution exceeded the allowed timeout window.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "504-search-timeout-exceeded": {
                    "summary": "Error response when search execution exceeds the allowed timeout window.",
                    "value": {
                      "error": {
                        "code": "Failed",
                        "message": "gateway timeout"
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    },
    "/visitors/{visitor_id}": {
      "get": {
        "tags": [
          "Fingerprint"
        ],
        "operationId": "getVisits",
        "summary": "Get visits by visitor ID",
        "description": "> 🚧 Deprecation Notice\n>\n> This version of Server API is marked as deprecated starting on **Jan 7th 2026** according to our [API Deprecation Policy](https://docs.fingerprint.com/reference/api-deprecation-policy). If you still use this version, please follow our [migration guide](https://docs.fingerprint.com/reference/migrating-from-server-api-v3-to-v4#migrating-get-/visitors) to migrate from this deprecated version to the new one.\n\nThis endpoint is deprecated. Use `GET /events/search` to query visit history or filter across multiple events.\n\n`GET /visitors/{visitor_id}` currently returns at most one visit in `visits`, even when no filters are provided.\nOnly information from the _Identification_ product is returned.\n\n#### Headers\n\n* `Retry-After` — Present in case of `429 Too many requests`. Indicates how long you should wait before making a follow-up request. The value is non-negative decimal integer indicating the seconds to delay after the response is received.\n",
        "x-flatten-optional-params": true,
        "parameters": [
          {
            "name": "visitor_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "Unique [visitor identifier](https://docs.fingerprint.com/reference/v3/js-agent-get-function#visitorid) issued by Fingerprint Identification and all active Smart Signals."
          },
          {
            "name": "request_id",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "description": "Filter visits by `requestId`.\n\nEvery identification request has a unique identifier associated with it called `requestId`. This identifier is returned to the client in the identification [result](https://docs.fingerprint.com/reference/v3/js-agent-get-function#requestid). When you filter visits by `requestId`, only one visit will be returned.\n",
            "x-go-skip-pointer": true
          },
          {
            "name": "linked_id",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "description": "Filter visits by your custom identifier.\n\nYou can use [`linkedId`](https://docs.fingerprint.com/reference/v3/js-agent-get-function#linkedid) to associate identification requests with your own identifier, for example: session ID, purchase ID, or transaction ID. You can then use this `linked_id` parameter to retrieve all events associated with your custom identifier.\n",
            "x-go-skip-pointer": true
          },
          {
            "name": "limit",
            "in": "query",
            "schema": {
              "type": "integer",
              "format": "int32",
              "minimum": 0
            },
            "description": "Limit scanned results.\n\n`GET /visitors/{visitor_id}` currently returns at most one visit. Use `GET /events/search` for paginated multi-event queries.\n",
            "x-go-skip-pointer": true
          },
          {
            "name": "paginationKey",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "description": "Deprecated pagination parameter retained for backward compatibility.\n\n`GET /visitors/{visitor_id}` currently returns at most one visit, so pagination is not expected. Use `GET /events/search` for paginated results.\n",
            "x-go-skip-pointer": true
          },
          {
            "name": "before",
            "in": "query",
            "deprecated": true,
            "schema": {
              "type": "integer",
              "format": "int64",
              "minimum": 0
            },
            "description": "⚠️ Deprecated pagination method, please use `paginationKey` instead. Timestamp (in milliseconds since epoch) used to paginate results.\n`GET /visitors/{visitor_id}` currently returns at most one visit, so pagination is not expected.\n",
            "x-go-skip-pointer": true
          }
        ],
        "responses": {
          "200": {
            "description": "OK.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/VisitorsGetResponse"
                },
                "examples": {
                  "200-limit-1": {
                    "summary": "Example response (single visit)",
                    "value": {
                      "visitorId": "AcxioeQKffpXF8iGQK3P",
                      "visits": [
                        {
                          "requestId": "1655373953086.DDlfmP",
                          "browserDetails": {
                            "browserName": "Chrome",
                            "browserMajorVersion": "102",
                            "browserFullVersion": "102.0.5005",
                            "os": "Mac OS X",
                            "osVersion": "10.15.7",
                            "device": "Other",
                            "userAgent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/102.0.5005.61 Safari/537.36"
                          },
                          "incognito": false,
                          "ip": "82.118.30.68",
                          "ipLocation": {
                            "accuracyRadius": 1000,
                            "latitude": 50.0805,
                            "longitude": 14.467,
                            "postalCode": "130 00",
                            "timezone": "Europe/Prague",
                            "city": {
                              "name": "Prague"
                            },
                            "country": {
                              "code": "CZ",
                              "name": "Czechia"
                            },
                            "continent": {
                              "code": "EU",
                              "name": "Europe"
                            },
                            "subdivisions": [
                              {
                                "isoCode": "10",
                                "name": "Hlavni mesto Praha"
                              }
                            ]
                          },
                          "timestamp": 1655373953094,
                          "time": "2022-06-16T10:05:53Z",
                          "url": "https://dashboard.fingerprint.com/",
                          "tag": {},
                          "confidence": {
                            "score": 1
                          },
                          "visitorFound": true,
                          "firstSeenAt": {
                            "global": "2022-02-04T11:31:20.000Z",
                            "subscription": "2022-02-04T11:31:20.000Z"
                          },
                          "lastSeenAt": {
                            "global": "2022-06-16T10:03:00.912Z",
                            "subscription": "2022-06-16T10:03:00.912Z"
                          }
                        }
                      ],
                      "lastTimestamp": 1655373953086,
                      "paginationKey": "1655373953086.DDlfmP"
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Bad request. The visitor ID or query parameters are missing or in the wrong format.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorPlainResponse"
                },
                "examples": {
                  "400-bad-request": {
                    "summary": "Error response when the visitor ID or query parameters are missing or in the wrong format.",
                    "value": {
                      "error": "bad request"
                    }
                  }
                }
              }
            }
          },
          "403": {
            "description": "Forbidden. Access to this API is denied.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorPlainResponse"
                },
                "examples": {
                  "403-forbidden": {
                    "summary": "Error response when the secret API Key is missing or incorrect.",
                    "value": {
                      "error": "Forbidden (HTTP 403)"
                    }
                  }
                }
              }
            }
          },
          "404": {
            "description": "Not found. The visitor ID cannot be found in this application's data.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorPlainResponse"
                },
                "examples": {
                  "404-not-found": {
                    "summary": "Error response when the provided visitor ID does not exist.",
                    "value": {
                      "error": "visitor not found"
                    }
                  }
                }
              }
            }
          },
          "429": {
            "description": "Too Many Requests. The request is throttled.\nTo protect service stability during rare periods of extreme load, we may return HTTP 429 responses with message `too many search requests` even if you are within your assigned rate limits.\n",
            "headers": {
              "Retry-After": {
                "description": "Indicates how many seconds you should wait before attempting the next request.",
                "schema": {
                  "type": "integer",
                  "format": "int32",
                  "minimum": 0
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorPlainResponse"
                },
                "examples": {
                  "429-too-many-requests": {
                    "summary": "Error response when the limit on the provided secret API key requests per second has been exceeded.",
                    "value": {
                      "error": "too many requests"
                    }
                  },
                  "429-too-many-search-requests": {
                    "summary": "Error response when visitor search traffic is throttled to protect service stability during rare periods of extreme load, even if you are within your assigned rate limits.",
                    "value": {
                      "error": "too many search requests"
                    }
                  }
                }
              }
            }
          },
          "504": {
            "description": "Gateway Timeout. Search execution exceeded the allowed timeout window.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "504-search-timeout-exceeded": {
                    "summary": "Error response when search execution exceeds the allowed timeout window.",
                    "value": {
                      "error": {
                        "code": "Failed",
                        "message": "gateway timeout"
                      }
                    }
                  }
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Fingerprint"
        ],
[...]
